#include <iostream>
#include <fstream>
#include <unordered_map>

#define N 1000000
using namespace std;

int a[N];

int main() {
    int test_cases;
    ifstream fin("jancsi.in");
    if (!fin) {
        cerr << "Could not open the file!" << endl;
        return 1;
    }
    ofstream ofs("jancsi.out");
    fin >> test_cases;
    int x;
    for (int t = 0; t < test_cases; ++t) {
        int n, m, k;
        fin >> n >> m >> k;
        for (int i = 0; i < n; ++i) {
            fin >> a[i];
        }
        unordered_map<int, int> count_b;
        for (int i = 0; i < m; ++i) {
            fin >> x;
            count_b[x]++;
        }

        int good_sequences = 0;

        // compute frequencies of elements in the first subarray of length m
        unordered_map<int, int> count_c;
        for (int i = 0; i < m; ++i) {
            count_c[a[i]]++;
        }

        // counter - number of elements in the subarray that are in the set of elements that we are looking for
        int counter = 0;
        for (auto [key, value]: count_b) {
            counter += (count_c[key] < value) ? count_c[key] : value;
        }
        if (counter >= k) {
            ++good_sequences;
        }
        // iterate over all subarrays of length m
        for (int i = 1; i <= n - m; ++i) {
            // update the frequencies for the next subarray
            // these are the same as in the previous subarray except for the first element and the last element

            // remove from counter the contribution of the first element of the previous subarray
            int element = a[i - 1];
            count_c[element]--;
            if(count_c[element] < count_b[element] ) {
                counter--;
            }

            // add the contribution of the last element of the current subarray
            element = a[i + m - 1];
            count_c[element]++;
            counter += (count_c[element] <= count_b[element]) ? 1 : 0;

            // check if the current subarray represented by count_c is good
            if (counter >= k) {
                ++good_sequences;
            }
        }
        ofs << good_sequences << endl;
    }
    return 0;
}

